package sun.rmi.transport;

import java.io.ObjectInput;
import java.rmi.server.SkeletonMismatchException;
import java.rmi.dgc.Lease;
import java.rmi.MarshalException;
import java.io.IOException;
import java.rmi.UnmarshalException;
import java.rmi.dgc.VMID;
import java.rmi.server.ObjID;
import java.rmi.server.RemoteCall;
import java.rmi.Remote;
import java.rmi.server.Operation;
import java.rmi.server.Skeleton;

public final class DGCImpl_Skel implements Skeleton
{
    private static final Operation[] operations;
    private static final long interfaceHash = -669196253586618813L;
    
    public DGCImpl_Skel() {
    }
    
    @Override
    public Operation[] getOperations() {
        return (Operation[])DGCImpl_Skel.operations.clone();
    }
    
    @Override
    public void dispatch(Remote remote, RemoteCall remoteCall, int n, long n2) throws Exception {
        if (n2 != -669196253586618813L) {
            throw new SkeletonMismatchException("interface hash mismatch");
        }
        DGCImpl dgcImpl = (DGCImpl)remote;
        StreamRemoteCall streamRemoteCall = (StreamRemoteCall)remoteCall;
        switch (n) {
            case 0: {
                ObjID[] array;
                long long1;
                VMID vmid;
                int boolean1;
                try {
                    ObjectInput inputStream = streamRemoteCall.getInputStream();
                    array = (ObjID[])(ObjID[])inputStream.readObject();
                    long1 = inputStream.readLong();
                    vmid = (VMID)inputStream.readObject();
                    boolean1 = inputStream.readBoolean();
                }
                catch (ClassCastException | IOException | ClassNotFoundException ex) {
                    streamRemoteCall.discardPendingRefs();
                    throw new UnmarshalException("error unmarshalling arguments", ex);
                }
                finally {
                    streamRemoteCall.releaseInputStream();
                }
                dgcImpl.clean(array, long1, vmid, (boolean)boolean1);
                try {
                    streamRemoteCall.getResultStream(true);
                    break;
                }
                catch (IOException ex2) {
                    throw new MarshalException("error marshalling return", ex2);
                }
            }
            case 1: {
                ObjID[] array2;
                long long2;
                Lease lease;
                try {
                    ObjectInput inputStream2 = streamRemoteCall.getInputStream();
                    array2 = (ObjID[])(ObjID[])inputStream2.readObject();
                    long2 = inputStream2.readLong();
                    lease = (Lease)inputStream2.readObject();
                }
                catch (ClassCastException | IOException | ClassNotFoundException ex3) {
                    streamRemoteCall.discardPendingRefs();
                    throw new UnmarshalException("error unmarshalling arguments", ex3);
                }
                finally {
                    streamRemoteCall.releaseInputStream();
                }
                Lease dirty = dgcImpl.dirty(array2, long2, lease);
                try {
                    streamRemoteCall.getResultStream(true).writeObject(dirty);
                    break;
                }
                catch (IOException ex4) {
                    throw new MarshalException("error marshalling return", ex4);
                }
            }
            default: {
                throw new UnmarshalException("invalid method number");
            }
        }
        return;
    }
    
    static {
        operations = new Operation[] { new Operation("void clean(java.rmi.server.ObjID[], long, java.rmi.dgc.VMID, boolean)"), new Operation("java.rmi.dgc.Lease dirty(java.rmi.server.ObjID[], long, java.rmi.dgc.Lease)") };
    }
}
